package com.zsc.edu.dify.modules.dify.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.zsc.edu.dify.modules.dify.entity.AppsResponse;
import com.zsc.edu.dify.modules.dify.mapper.DifyServeMapper;
import com.zsc.edu.dify.modules.dify.repo.DifyServeRepository;
import io.github.guoshiqiufeng.dify.server.DifyServer;
import io.github.guoshiqiufeng.dify.server.dto.response.AppsResponseVO;
import jakarta.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author zhuang
 */
@Slf4j
@Service
public class DifyServeService {
    @Resource
    DifyServer difyServer;
    @Resource
    DifyServeRepository difyServeRepository;
    @Resource
    DifyServeMapper difyServeMapper;
    public List<AppsResponseVO> apps(String mode, String name) {
        return addApps(difyServer.apps(mode, name));
    }

    public List<AppsResponseVO> addApps(List<AppsResponseVO> apps) {
        for(AppsResponseVO app : apps){
            boolean isHave = difyServeRepository.exists(new LambdaQueryWrapper<AppsResponse>().eq(AppsResponse::getId, app.getId()));
            if(isHave){
                difyServeRepository.updateById(difyServeMapper.toEntity(app));
            }else {
                difyServeRepository.insert(difyServeMapper.toEntity(app));
            }
        }
        return apps;
    }
}
